{ 
$Id: fpc_udf_int_math.pp,v 0.1 2000/07/11 07:36:07 frank Exp $
(C)2000 Frank Schlottmann-Goedde
integer mathematics
user defined functions (UDF)
for Interbase 6.0 SS for Linux
use at your own risc
}

library FPC_UDF_int_math;
{$mode objfpc}  {so we can use result keyword .-)}

const Err_val=-9999;

function int_max(var a,b:longint):longint;export; 
begin
  if a>b then
    result:=a
  else
    result:=b;
end;

function int_min(var a,b:longint):longint;export; 
begin
  if a<b then
    result:=a
  else
    result:=b;
end;

function int_div(var a,b:longint):longint;export;
begin
  if b<>0 then
    result:=a div b
  else
    result:=Err_val;
end;

function int_mod(var a,b:longint):longint;export;
begin
  if b<>0 then
    result:=a mod b
  else
    result:=Err_val;
end;

function int_and(var a,b:longint):longint;export;
begin
  result:=a and b;
end;

function int_or(var a,b:longint):longint;export;
begin
  result:=a or b;
end;

function int_xor(var a,b:longint):longint;export;
begin
  result:=a xor b;
end;

function int_not(var a:longint):longint;export;
begin
  result:=not(a);
end;

function int_abs(var a:longint):longint;export;
begin
  result:=abs(a);
end;

exports
 int_max name 'int_max',
 int_min name 'int_min',
 int_div name 'int_div',
 int_mod name 'int_mod',
 int_and name 'int_and',
 int_or  name 'int_or',
 int_not name 'int_not', 
 int_abs name 'int_abs',
 int_xor name 'int_xor';
 
end.